// Example by Tom Igoe
//Shinshu Makers customiazed
//  Serial Speed 460800bps Recieving OK
//  Recieving 600000 sample data  
//Push 'q' key stop program and Save CSV file 
import controlP5.*;//TEXT DISPLAY library
ControlP5 cp5tl;
Textlabel tl1,tl2;
import processing.serial.*; //serial library
PrintWriter output;//file saving declaration
int lf = 10;    // Linefeed in ASCII
int cr=13;      // NA
String myString = null;//buffer
Serial myPort;  // The serial port declaration
int i,j;
int elapsedTime;
int startTime;
int endTime;
int endFlag=0;
 String [] mystringArry=new String[600000]; //recived data 
void setup() {
//--------------- TEXT Diplay-------------------------
  size(600,100);
 background(0,0,0);
 PFont font;
 font=createFont("Times New Roman",30);
 textFont(font);
 //Display Comments
 cp5tl=new ControlP5(this);
 tl1=cp5tl.addTextlabel("lable1");
tl1.setText(" Data Sampling ==>Push 'q ' save CSV&Stop");
tl1.setFont(font);
//---------------------------------------------------------
  // List all the available serial ports
  printArray(Serial.list());//Serch  serial portNo=Serila.list(No) 
  // Open the port you are using at the rate you want:
  myPort = new Serial(this, Serial.list()[0], 460800);//COM No set and baud rate set
  myPort.clear();
  // Throw out the first reading, in case we started reading 
  // in the middle of a string from the sender.
  myString = myPort.readStringUntil(lf);//LF delimitor 
  myString = null;
  // CSV FILE TIME STAMP
  String filename = nf(year(),4) + nf(month(),2) + nf(day(),2) + nf(hour(),2) + nf(minute(),2) ;
  output = createWriter( filename + ".csv");
  i=0;
}

void draw() {
 // LOOP Serial Recieved data are stored to mystringArry[]
  while (myPort.available() > 0) {
    myString = myPort.readStringUntil(cr);
    if (myString != null) {
      if (i==0){startTime=millis();}
      i++;//data cout
      print(i,myString);
      mystringArry[i]=myString;
       }
      
    }
  }
 
 
// Key 'q' Interrupt and Save CSV FILE  de Program end
void keyPressed(){
   int k;
   String[] datastr=new String[100];//1 line 100chara
  if( key == 'q' ){
     for(k=0;k<i;k++){ //i data counted
       output.print(mystringArry[k]);
      }
    output.flush(); 
    output.close(); 
    exit();               
  }
}